> ## Documentation Index
> Fetch the complete documentation index at: https://docs.uniblock.dev/llms.txt
> Use this file to discover all available pages before exploring further.

# Get Address Token Balance History

> Get the historical token balances of an address.



## OpenAPI

````yaml /reference/api-json.json get /token/balance/historical
openapi: 3.0.0
info:
  title: Unified Request
  description: One API for all your web3 needs.
  version: '1.0'
  contact: {}
servers:
  - url: https://api-test.uniblock.dev/uni/v1
    description: Test-Gateway
security:
  - {}
  - ApiKeyAuth: []
tags: []
paths:
  /token/balance/historical:
    get:
      tags:
        - Token
      summary: Get Address Token Balance History
      description: Get the historical token balances of an address.
      operationId: WalletTokenHistoricalBalance
      parameters:
        - name: chainId
          required: true
          in: query
          description: Unique identifier for a blockchain network.
          schema:
            default: 1
            example: 1
            enum:
              - 1
              - 10
              - 100
              - 10200
              - 1088
              - 1101
              - 11155111
              - 11155420
              - 11297108109
              - 1135
              - 1284
              - 1285
              - 1329
              - 137
              - 1666600000
              - 167000
              - 167009
              - 2020
              - 2442
              - 248
              - 25
              - 250
              - 288
              - 300
              - 324
              - 369
              - 4002
              - 4202
              - 42161
              - 421614
              - 42170
              - 42220
              - 43113
              - 43114
              - 5000
              - 534351
              - 534352
              - 545
              - 56
              - 59141
              - 59144
              - 7000
              - 7001
              - 747
              - 80002
              - 80094
              - 81457
              - 8453
              - 84532
              - 88882
              - 88888
              - 9001
              - 97
              - solana
              - solana-devnet
            type: string
        - name: walletAddress
          required: true
          in: query
          description: The address of the wallet to query.
          schema:
            default: '0x8D97689C9818892B700e27F316cc3E41e17fBeb9'
            example: '0x8D97689C9818892B700e27F316cc3E41e17fBeb9'
            type: string
        - name: timestamp
          required: false
          in: query
          description: The timestamp of the historical balance to query.
          schema:
            default: 1625097600
            example: 1625097600
            type: number
        - name: blockNumber
          required: false
          in: query
          description: The block number of the historical balance to query.
          schema:
            type: number
        - name: includePrice
          required: false
          in: query
          description: >-
            When set to true it will return the USD value of the specified
            token.
          schema: {}
        - name: includeMetadata
          required: false
          in: query
          description: >-
            When set to true it will return the token metadata along with the
            balance.
          schema: {}
        - name: cursor
          required: false
          in: query
          description: Cursor from previous query to get next page of results.
          schema:
            type: string
        - name: includeRaw
          required: false
          in: query
          description: >-
            Returns the raw data given by the provider. WARNING: removes backup
            feature, and raw data returned is not normalized which might make
            switching providers difficult
          schema:
            example: null
            type: boolean
        - name: provider
          required: false
          in: query
          description: >-
            Specify which provider to use. The project's provider priority list
            is used by default if no providers are selected. (Priority list can
            be managed on Uniblock's dashboard)
          schema:
            enum:
              - GoldRush
              - Moralis
            type: string
      responses:
        '200':
          description: ''
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/WalletTokenHistoricalBalanceResponse'
components:
  schemas:
    WalletTokenHistoricalBalanceResponse:
      type: object
      properties:
        balances:
          type: array
          items:
            $ref: '#/components/schemas/WalletTokenBalanceResponseItem'
        cursor:
          type: string
          example: >-
            ALC_MHgyMzEyZjAwMTQ5ZDAxMDgwNmQ5ZWY2ZjNlYTMyMGViMWUxYTZiYzhlOjB4MDAwMDAwMDAwMDAwMDAwMDAwMDAwMDAwMDAwMDAwMDAwMDAwMDAwMDAwMDAwMDAwMDAwMDAwMDAwMDAwMDFhYTpmYWxzZQ==
        blockNumber:
          type: string
          example: '17941778'
        timestamp:
          type: string
          example: '17941778'
      required:
        - balances
        - cursor
        - blockNumber
        - timestamp
    WalletTokenBalanceResponseItem:
      type: object
      properties:
        contractAddress:
          type: string
          example: '0xdAC17F958D2ee523a2206206994597C13D831ec7'
          description: The contract address of the token or the mint of the Solana token.
        balance:
          type: string
          example: '199999999999'
        formattedBalance:
          type: string
          example: '19.9999999999'
          description: The formatted balance of the token.
        name:
          type: object
          example: Ethereum
        symbol:
          type: object
          example: ETH
        logo:
          type: object
          example: https://assets.coingecko.com/coins/images/279/large/ethereum.png
        decimals:
          type: object
          example: '18'
        associatedTokenAddress:
          type: string
          example: EkSPbKodUFbYmsX5LuvfnSoRAozZ3kxT9wy71pf6eL2d
      required:
        - contractAddress
        - balance
        - formattedBalance
        - name
        - symbol
        - logo
        - decimals
  securitySchemes:
    ApiKeyAuth:
      type: apiKey
      in: header
      name: X-API-KEY
      description: API key to access the API (optional)

````